if Damnation.class ~= "PALADIN" then return end
local Damnation = Damnation

local GetPlayerBuffName = GetPlayerBuffName
local CancelPlayerBuff = CancelPlayerBuff

local GBoS = Damnation.GBoS or "Greater Blessing of Salvation"
local BoS = Damnation.BoS or "Blessing of Salvation"
local RF = Damnation.RF or "Righteous Fury"
--[[ For testing
GBoS = "Shadowguard"
BoS = "Shadowguard"
RF = "Inner Fire"
--]]

local f = Damnation.f

function Damnation:SetAutoMode(verbose)
	f:SetScript("OnEvent", Damnation.OnEvent)
	f:RegisterEvent("UNIT_AURA")
	if verbose then self:Print("Mode is set to \"|cff00ff00auto|r\". Will remove BoS when you have Righteous Fury active.") end
	self:AutoDamn()
end

function Damnation:AutoMode(unit)
	-- Break early if the event wasn't for the player
	-- or if the player don't have Righteous Fury
	if unit ~= "player" then return end
	-- Waiting to next frame before reacting to the UNIT_AURA event.
	-- GetPlayerBuffName(BoS) (with string instead of index) won't work right away for the buff just gained
	f:SetScript("OnUpdate", Damnation.AutoDamn)
end

function Damnation:AutoDamn()
	f:SetScript("OnUpdate", nil)
	if not GetPlayerBuffName(RF) then return end
	local name = GetPlayerBuffName(GBoS) or GetPlayerBuffName(BoS)
	if name then
		CancelPlayerBuff(name)
	end
end
